/* UniPhier Cache flushing
 *
 * Copyright (C) 2007 Red Hat, Inc. All Rights Reserved.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */
#ifndef _ASM_ARCH_CACHEFLUSH_H
#define _ASM_ARCH_CACHEFLUSH_H

#include <asm/armv7.h>

#undef PAGE_SIZE
#define PAGE_SIZE		4096
#define PAGE_MASK		(~(PAGE_SIZE-1))

#define L1_CACHE_SHIFT		(5)		/* CONFIG_ARM_L1_CACHE_SHIFT */
#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)

#ifndef CONFIG_SYS_L2CACHE_OFF
#define L2_CACHE_SHIFT		(7)
#define L2_CACHE_BYTES		(1 << L2_CACHE_SHIFT)

#define L2_CACHE_ADRS_MASK	(~(L2_CACHE_BYTES - 1))
#endif /* CONFIG_SYS_L2CACHE_OFF */

//#define PURGE_CACHE_D_PURGE	0x00
#define PURGE_CACHE_D_PURGE_INV	0x01
//#define PURGE_CACHE_ID_SYNC	0x02
#define PURGE_CACHE_D_INV	0x03
//#define PURGE_CACHE_I_INV	0x04
#define PURGE_CACHE_D_INV_BEFORE_DMA	0x05
#define PURGE_CACHE_D_INV_AFTER_DMA	0x06

#define	SIZE_ALL_CACHE		0xffffffffUL

#ifndef __ASSEMBLY__

/* L1 Cache */
extern void invalidate_L1_dcache_range(unsigned long start, unsigned long stop);
extern void flush_L1_dcache_range(unsigned long start, unsigned long stop);

/* L2 Cache */
#define invalidate_L2_dcache_range(start, stop)	v7_outer_cache_inval_range(start, stop)
#define flush_L2_dcache_range(start, stop)	v7_outer_cache_flush_range(start, stop)

#endif /* !__ASSEMBLY__ */

#endif /* _ASM_ARCH_CACHEFLUSH_H */
