/*
 * Copyright (C) 2010 Panasonic Corporation
 * All Rights Reserved.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <common.h>
#include <asm/mach-types.h>
#include <config.h>
#include <netdev.h>

DECLARE_GLOBAL_DATA_PTR;

#ifdef CONFIG_UNIPHIER_AVEV3
int mn_avev3_initialize(int dev_num, int base_addr);
#endif

/*
 * Routine: board_init
 * Description: Early hardware init.
 */
int board_init(void)
{
	/* board id for Linux */
	gd->bd->bi_arch_number = MACH_TYPE_MN2WS0270_REF;
	/* boot param addr */
	gd->bd->bi_boot_params = (LINUX_BOOT_PARAM_ADDR);

	gd->flags = 0;

	return 0;
}

#ifdef CONFIG_CMD_NET
int board_eth_init(bd_t *bis)
{
	int rc = 0;

#ifdef CONFIG_SMC911X
	if (smc911x_initialize(0, CONFIG_SMC911X_BASE) > 0)
		rc++;
#endif

#ifdef CONFIG_UNIPHIER_AVEV3
	if (mn_avev3_initialize(0, CONFIG_UNIPHIER_ETHERNET_BASE) > 0)
		rc++;
#endif

	return rc;
}
#endif /* CONFIG_CMD_NET */
