/* nand-mn2ws-unit.h: unit-specific mtd file
 *
 * Copyright (C) 2006-2008 Panasonic Corporation
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#ifndef _ASM_UNIT_NAND_MN2WS_UNIT_H
#define _ASM_UNIT_NAND_MN2WS_UNIT_H

//#
//# Architecture dependent settings
//#

//Memory map of nand-gpbc
#define NAND_GPBC_UNIT_MEM_BASE		CONFIG_SYS_NAND_BASE
#define NAND_GPBC_UNIT_MEM_SIZE		CONFIG_SYS_NAND_IOREMAP_SIZE
#define NAND_GPBC_UNIT_REG_BASE		CONFIG_SYS_NAND_REG_BASE
#define NAND_GPBC_UNIT_REG_SIZE		CONFIG_SYS_NAND_REG_IOREMAP_BASE
#define NAND_GPBC_UNIT_RESET_BASE	CONFIG_SYS_NAND_REST_BASE
#define NAND_GPBC_UNIT_RESET		CONFIG_SYS_NAND_REST

#ifdef	CONFIG_MTD_NAND_MN2WS_BB
#define NAND_MN2WS_AREA_ORDER		CONFIG_SYS_NAND_AREA_ORDER
#endif	//CONFIG_MTD_NAND_MN2WS_BB

// If maximum number of the corrected bit of each sector is larger than
// this definition, -EUCLEAN is notified to upper layer.
// If uncorrectable error occurs, -EBADMSG is notified to upper layer.
#define NAND_GPBC_CORRECTION_THRESHOLD	CONFIG_MTD_NAND_MN2WS_CORRECT_ERROR_BITS

//#
//# Partition settings
//#

/* NOTICE: Partition setting has been moved to unit-init.c */

#endif	//_ASM_UNIT_NAND_MN2WS_UNIT_H
